#!/usr/bin/env octave

% N prbek sygnau x(t)=A*sin(2*pi*fx*t)+A/2*sin(2*pi*2*fx*t)+A/4*sin(2*pi*4*fx*t)
% o amplitudzie A=5V. Czstotliwo fx=10Hz, prbkowanie z czstotliwoci fp=1000Hz

N=2000; A=5; fx=10; fp=1000;
dt=1/fp;
t=dt*(0:N-1);
x=A * sin(2*pi*fx*t) + A/2 * sin(2*pi*fx*2*t) +  A/4 * sin(2*pi*fx*4*t); %Sygna

clf;
subplot(211); plot(t,x); grid; title('Sygna x(t)'); xlabel('czas [s]');

K=xcorr(x); %Nieunormowana autokorelacja
tt=[-fliplr(t) t(2:N)]; %tR <-2...0...2>
subplot(212); plot(tt,K); grid; title('Autokorelacja');

pause;

%Wspczynniki zespolonego szeregu Fouriera dla tego sygnau
%(cz rzeczywista, urojona, modu wspczynnikw)

X = fft(x);   %szybka, dyskretna transformacja Fouriera
df = 1/(N*dt); %czstotliwo podstawowa f0=df=1/T=1/(N*dt)
f= df*(0:N-1);   %kolejne czstotliwoci w szeregu Fouriera
subplot(221); plot(f,real(X)); grid; title('Real(X)'); xlabel('Hz');
subplot(222); plot(f,imag(X)); grid; title('Imag(X)'); xlabel('Hz');
subplot(223); plot(f,abs(X)); grid; title('Abs(X)'); xlabel('Hz');
%subplot(224); plot(f(1:N/2+1),abs(X(1:N/2+1))/(N/2)); grid; title('Po wyskalowaniu'); pause
subplot(224); plot(f(1:N/8+1),abs(X(1:N/8+1))/(N/2)); grid; title('Po wyskalowaniu - i ograniczona czestosc'); pause
